<?PHP
/* 	
SIGNUM-NET Włodzimierz Kessler
	Skrypt do wczytywania danych wysyłanych z programu FARA do bazy danych MySQL
	Wszelkie prawa zastrzeżone
	Dopuszcza się modyfikacje tego skryptu we własnym zakresie na własne potrzeby
	NIEDOZWOLONE jest odsprzedawanie tego skryptu
	
	Skrypt testowany był w określonym środowisku systemu operacyjnego, języka PHP i bazy MySQL
	
	!!! Nie ma żadnej gwarancji, że skrypt będzie działał prawidłowo w Twoim środowisku. Należy przed jego wdrożeniem samodzielnie sprawdzić jego działanie na docelowym serwerze !!!
*/

define ("FARA_INTENTIONS_SOURCE_FOLDER"	, 'fara-intencje-online');
define ("FARA_ZGLOSZENIA_FOLDER"		, 'zgloszenia');

define ("FARA_INTENTIONS_TABLE"			, 'faraIntencje');
define ("FARA_INTENTIONS_TYPES_TABLE"	, 'faraTypyIntencji');
define ("FARA_CHURCHES_TABLE"			, 'faraIntencjeKoscioly');
define ("FARA_SAINTS_TABLE"				, 'faraPatroniNiemodyfikowane');
define ("FARA_USER_SAINTS_TABLE"		, 'faraPatroniModyfikowane');
define ("FARA_MCELEBRATIONS_TABLE"		, 'faraSwietaRuchome');
define ("FARA_CCELEBRATIONS_TABLE"		, 'faraSwietaStale');

define ("FARA_INTENTIONS_FILE_TYPE"			, 'fara_intencje');
define ("FARA_INTENTIONS_DELETE_FILE_TYPE"	, 'fara_intencje_deleted');
define ("FARA_INTENTIONS_TYPES_FILE_TYPE"	, 'fara_intencje_typy');
define ("FARA_CHURCHES_FILE_TYPE"			, 'fara_intencje_koscioly');
define ("FARA_SAINTS_FILE_TYPE"				, 'fara_patroni_niemodyfikowane');
define ("FARA_USER_SAINTS_FILE_TYPE"		, 'fara_patroni_modyfikowane');
define ("FARA_MCELEBRATIONS_FILE_TYPE"		, 'fara_swieta_ruchome');
define ("FARA_CCELEBRATIONS_FILE_TYPE"		, 'fara_swieta_stale');

define ("FARA_DEFAULT_INI_STYLES_FILE"		, 'fara_intencje_online.ini');

// zgłoszenia
define ("zgRezerwowanie"						, 'tekst w trakcie rezerwowania');
define ("zgWalidacja"							, 'walidacja');
define ("zgTypNieWalidowany"					, 'typ wykluczony z walidacji');
define ("zgPotwierdzona"						, 0);
define ("zgNiePotwierdzona"						, 1);

define ("FARA_WSZYSTKIE_KOSCIOLY"			,  -1);
define ("FARA_DATA_POZA_ZAKRESEM"			,  -2);
define ("FARA_TERMIN_BRAK_DANYCH"			,  -1);
define ("FARA_TERMIN_WOLNY"					,   1);
define ("FARA_TERMIN_ZAJETY"				,   0);
define ("FARA_TERMIN_DOWOLNY"				,   2);
define ("FARA_DATABASE_CONNECTION_CANCELED"	,-100);
define ("FARA_SEPARATOR_TERMINOW"			,', ' );
define ("FARA_FORMAT_DATY_DOMYSLNY"			, '%d.%m.%Y');

define ("sysKeyHistory"							, 'historia');
define ("FARA_INTENCJE_WSZYSTKO"				, 0);
define ("FARA_INTENCJE_OD_DZISIAJ"				, 1);
define ("FARA_INTENCJE_OD_BIEZACEGO_TYGODNIA"	, 2);
define ("FARA_INTENCJE_OD_BIEZACEGO_MIESIACA"	, 3);
define ("FARA_INTENCJE_OD_POCZATKU_ROKU"		, 4);
define ("FARA_INTENCJE_OD_NASTEPNEGO_TYGODNIA"	, 5);
define ("FARA_INTENCJE_OD_NASTEPNEGO_MIESIACA"	, 6);
define ("FARA_INTENCJE_OD_NASTEPNEGO_ROKU"		, 7);

define ("FARA_KEYWORD_DATA"						, '$data');
define ("FARA_KEYWORD_GODZINA"					, '$godzina');
define ("FARA_KEYWORD_KOSCIOL"					, '$kosciol');
define ("FARA_KEYWORD_TYTUL"					, '$tytuł');

define ("FARA_ZGLOSZENIE_TERMIN_ZAJETY"			, 0);
define ("FARA_ZGLOSZENIE_TERMIN_PRZYJETY"		, 1);
define ("FARA_ZGLOSZENIE_BLAD_WYSYLANIA"		, -1);

$fara = new FaraIntentionsCalendar();

if (isset ($_GET['tryb']) and strtolower ($_GET['tryb'])=='instaluj') $fara->install();
if (isset ($_GET['loading']) and $_GET['loading']==1) $fara->dataLoad(FARA_INTENTIONS_SOURCE_FOLDER);

class FaraIntentionsCalendar {
	var $dbSourceFolder 			= '';
	var $History					= FARA_INTENCJE_OD_BIEZACEGO_TYGODNIA;
	var $emailToSendErrorMessage	= '';
	var $emailSender				= '';

function __construct () {
require_once ('fara_intencje_online_konfiguracja.php');
$this->emailToSendErrorMessage 	= $emailToSendErrorMessage;
$this->emailSender				= $emailSender;
$this->dbSourceFolder			= $mainFolder.FARA_INTENTIONS_SOURCE_FOLDER;
@mysql_connect($dbHost, $dbUser, $dbPassword) or $this->sendErrorMessage ('Brak połączenia z bazą danych');
$config = $this->iniGetSection ('system', $this->getConfigFileName());
$this->history = $config[sysKeyHistory];
mysql_select_db($dbName);
}

function sendErrorMessage ($command) {
if (strlen ($this->emailToSendErrorMessage) > 0) {
	mail ($this->emailToSendErrorMessage, 
		  'Komunikat o błędzie w trakcie obsługi bazy terminów intencji na stronie WWW', 
		  $command,
		  '',
		  '-f'.$this->emailSender);
}
}

function dieWithMessage ($query) {
die ("Nie można wykonać operacji: <br/>".$query."<br/><br/>Error no: ".mysql_errno().": ".mysql_error());
}

// INSTALACJA - TWORZENIE TABLICY
function install () {
$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_CHURCHES_TABLE.'` (`faraID` integer NOT NULL,`nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);

$query 		= 'CREATE TABLE IF NOT EXISTS `'.FARA_INTENTIONS_TABLE.'` (`faraID` integer NOT NULL, `data` int (8) NOT NULL,`godzina` int (4) NOT NULL, `tresc` VARCHAR (10000) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL, `kosciolID` integer NOT NULL, `wolny` int (1) NOT NULL, gregorianka integer NOT NULL, `typID` integer NOT NULL,`nie_potwierdzona` int(1) NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);
$query 		= 'ALTER TABLE `'.FARA_INTENTIONS_TABLE.'` ADD INDEX (`data`)';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);
$query 		= 'ALTER TABLE `'.FARA_INTENTIONS_TABLE.'` ADD INDEX (`faraID`)';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_INTENTIONS_TYPES_TABLE.'` (`faraID` integer NOT NULL,`nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_SAINTS_TABLE.'` (`dzien` int (2) NOT NULL, `miesiac` int (2) NOT NULL,`nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`typ` VARCHAR (50) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);
$query 		= 'ALTER TABLE `'.FARA_SAINTS_TABLE.'` ADD INDEX (`dzien`)';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_USER_SAINTS_TABLE.'` (`faraID` integer NOT NULL,`dzien` int (2) NOT NULL, `miesiac` int (2) NOT NULL,`nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);
$query 		= 'ALTER TABLE `'.FARA_SAINTS_TABLE.'` ADD INDEX (`dzien`)';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_MCELEBRATIONS_TABLE.'` (`faraID` integer NOT NULL,`data` int (8) NOT NULL, `nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL,`typ` VARCHAR (100) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);
$query 		= 'ALTER TABLE `'.FARA_MCELEBRATIONS_TABLE.'` ADD INDEX (`data`)';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);

$query		= 'CREATE TABLE IF NOT EXISTS `'.FARA_CCELEBRATIONS_TABLE.'` (`faraID` integer NOT NULL,`dzien` int (2) NOT NULL, `miesiac` int (2) NOT NULL, `nazwa` VARCHAR (254) CHARACTER SET utf8 COLLATE utf8_polish_ci NOT NULL) DEFAULT CHARSET=utf8 COLLATE=utf8_polish_ci';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);
$query 		= 'ALTER TABLE `'.FARA_CCELEBRATIONS_TABLE.'` ADD INDEX (`dzien`)';
$handles	= @mysql_query ($query) or $this->dieWithMessage ($query);

$message	= '<html><head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>'.
			  '<p style="font-family:Verdana,Calibri,Arial;font-size:11px;">'.
			  'Instalacja została zakończona.<br/>W bazie danych zostały utworzone tablice:<ul>'.
			  '<li>'.FARA_INTENTIONS_TABLE.'</li>'.
			  '<li>'.FARA_INTENTIONS_TYPES_TABLE.'</li>'.
			  '<li>'.FARA_CHURCHES_TABLE.'</li>'.
			  '<li>'.FARA_SAINTS_TABLE.'</li>'.
			  '<li>'.FARA_USER_SAINTS_TABLE.'</li>'.
			  '<li>'.FARA_MCELEBRATIONS_TABLE.'</li>'.
			  '<li>'.FARA_CCELEBRATIONS_TABLE.'</li>'.
			  '</ul><br/>Proszę teraz wykonać pozostałe kroki konfiguracyjne'.
			  '</p></body></html>';
echo $message;			  
}

// ŁADOWANIE DANYCH Z PLIKÓW 
function dataLoad () {
$sourceDir = (func_num_args () > 0) ? func_get_arg (0) : $this->dbSourceFolder;
$pathHandle = opendir ($sourceDir);
if (!$pathHandle) {
	if (isset ($_GET['silent_mode']) and $_GET['silent_mode']=='0')
		echo 'Nie można odczytać zawartości katalogu: '.$sourceDir.'<br/>Ładowanie nie powiodło się';
	  else				
		$this->sendErrorMessage ('Nie można odczytać zawartości katalogu: '.$sourceDir);
	return;
}
$clear = (isset ($_GET['clear']) and $_GET['clear']==1);
// Skasowanie wpisów starszych niż dzisiaj lub wszystkich:
if ($clear) {
	// SKASOWANIE CAŁOŚCI
	$query = 'DELETE FROM  `'.FARA_INTENTIONS_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_INTENTIONS_TYPES_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);	
	$query = 'DELETE FROM  `'.FARA_CHURCHES_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_SAINTS_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_USER_SAINTS_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_MCELEBRATIONS_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
	$query = 'DELETE FROM  `'.FARA_CCELEBRATIONS_TABLE.'`';	
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych: '.$query);
} else if ($this->history>0) {
	// SKASOWANIE WPISÓW HISTORYCZNYCH
	$query = 'DELETE FROM  `'.FARA_INTENTIONS_TABLE.'` WHERE `data`<'.$this->getFirstDate();
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych historycznych: '.$query);
	$query = 'DELETE FROM  `'.FARA_MCELEBRATIONS_TABLE.'` WHERE `data`<'.$this->getFirstDate();
	@mysql_query ($query) or $this->sendErrorMessage ('Nie można skasować danych historycznych: '.$query);
}	
$total = 0;

// APPEND BLANK -> REPLACE MOŻE SPOWODWAĆ POWSTANIE 2 PLIKÓW DLA TEGO SAMEGO ID - TRZEBA TE PLIKI JAKOŚ TAK POSORTOWAĆ
// ŻEBY NAJPIERW PRZETWARZAĆ PLIKI STARSZE, A POTEM CORAZ MŁODSZE
// PLIKI TRZEBA WIĘC NAJPIERW POSORTOWAĆ WG. FUNKCJI FILEMTIME, a dopiero potem przetwarzać

while (false !== ($file = readdir($pathHandle))) 
	if (is_file ($sourceDir.'/'.$file)) {
		$localOrderInSession 	= substr ($file, 0, 6);
		$timeSignature			= substr ($file, 6, 16);
		$userID					= substr ($file, 22, 5);
		$key = $timeSignature.$localOrderInSession.$userID;				
		$files[$key] = $file;
	}
	
if (!isset ($files) or count ($files)==0) {
	if (isset ($_GET['silent_mode']) and $_GET['silent_mode']=='0')
		echo '<html><head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>'.
			'<p style="font-family:Verdana,Calibri,Arial;font-size:11px;">'.
			'Ładowanie zostało przeprowadzone, ale nie znaleziono żadnych danych do wczytania'.
			'</p></body></html>';
	return ;
}
ksort ($files);
closedir($pathHandle);
foreach ($files as $file) {
	$path = $sourceDir.'/'.$file;
	if 		(is_file ($path) and $this->fileNameExtension($path)==FARA_INTENTIONS_FILE_TYPE		) $total += $this->loadIntentions($path);
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_INTENTIONS_TYPES_FILE_TYPE	) $total += $this->loadIntentionsTypes($path);
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_CHURCHES_FILE_TYPE			) $total += $this->loadChurches($path);			 
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_SAINTS_FILE_TYPE			) $total += $this->loadSaints($path);			 
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_USER_SAINTS_FILE_TYPE		) $total += $this->loadUserSaints($path);			 
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_MCELEBRATIONS_FILE_TYPE	) $total += $this->loadMCelebrations($path);			 
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_CCELEBRATIONS_FILE_TYPE	) $total += $this->loadCCelebrations($path);
	else if (is_file ($path) and $this->fileNameExtension($path)==FARA_INTENTIONS_DELETE_FILE_TYPE) $total += $this->loadDeleteIntentions($path);
}

if (isset ($_GET['silent_mode']) and $_GET['silent_mode']=='0')
	echo '<html><head><meta http-equiv="content-type" content="text/html; charset=utf-8" /></head><body>'.
		 '<p style="font-family:Verdana,Calibri,Arial;font-size:11px;">'.
		 'Ładowanie danych zostało wykonane. Liczba zmian: '.$total.
		 '</p></body></html>';
}

function loadIntentions ($path) {
//rename ($path, $this->dbSourceFolder.'/trash/'. basename($path));
//$contentArray 	= file ($this->dbSourceFolder.'/trash/'. basename($path));
$contentArray 	= file ($this->dbSourceFolder.'/'. basename($path));
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  faraID, id kościoła, rrrrmmdd, ggmm, wolny (1|0), tresc
	$id			= trim ($info [0]);	
	if (strlen($id)==0) continue;
	$church		= $info [1];	
	$date		= $info [2];
	$time		= $info [3];
	$free		= $info [4];
	$gregorian	= $info [5];	
	$type		= $info [6];	
	$content	= trim (str_replace ('&pipe', '|', $info [7]));
	$niePotwierdzona = count($info)>8 ? $info [8] : 0;		
	$query		= 'DELETE FROM `'.FARA_INTENTIONS_TABLE.'` WHERE `faraID`='.$id;
	$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
	$total++;
	if ($date > 0 and $date >= $this->getFirstDate()) {
		$query		= 'INSERT INTO `'.FARA_INTENTIONS_TABLE.'` (`faraID`, `kosciolID`, `data`, `godzina`, `wolny`, `tresc`, `gregorianka`, `typID`, `nie_potwierdzona`) '.
					  'VALUES ('.$id.','.$church.','.$date.','.$time.','.$free.',"'.$content.'",'.$gregorian.','.$type.','.$niePotwierdzona.')';
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;
	}
}
return $total;
}

function loadDeleteIntentions ($path) {
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  faraID, id kościoła, rrrrmmdd, ggmm, wolny (1|0), tresc
	$date		= $info [0];	
	if (strlen($date)==0) continue;
	$church		= $info [1];	
	$query		= 'DELETE FROM `'.FARA_INTENTIONS_TABLE.'` WHERE `data`<'.$date;
	if ($church>0) $query .= ' and `kosciolID`='.$church;
	$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
	$total++;
}
return $total;
}

function loadChurches ($path) {
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);
	$id			= trim ($info [0]);
	if (strlen($id)==0) continue;
	$name		= trim (str_replace ('&pipe', '|', $info [1]));	
	$query = 'DELETE FROM  `'.FARA_CHURCHES_TABLE.'` WHERE `faraID`='.abs($id);		
	$sqlHandle = @mysql_query ($query) or $this->sendErrorMessage ($query);
	if ($id<0 and $sqlHandle) {
		// Skaowanie, powoduje też kasację danych z księgi intencji dotyczących tego kościoła
		$query = 'DELETE FROM  `'.FARA_INTENTIONS_TABLE.'` WHERE `kosciolID`='.abs($id);		
		$sqlHandle = @mysql_query ($query) or $this->sendErrorMessage ($query);
	} else {
		$name		= trim (str_replace ('&pipe', '|', $info [1]));		
		$query		= 'INSERT INTO `'.FARA_CHURCHES_TABLE.'` (`faraID`, `nazwa`) VALUES ('.$id.',"'.$name.'")';
		$sqlHhandle = @mysql_query ($query) or $this->sendErrorMessage ('Nie można wykonać: '.$query);		
	}
	$total++;
}	
return $total;
}

function loadIntentionsTypes ($path) {
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);
	$id			= trim ($info [0]);
	if (strlen($id)==0) continue;
	$name		= trim (str_replace ('&pipe', '|', $info [1]));	
	$query = 'DELETE FROM  `'.FARA_INTENTIONS_TYPES_TABLE.'` WHERE `faraID`='.abs($id);		
	$sqlHandle = @mysql_query ($query) or $this->sendErrorMessage ($query);
	if ($id>0 and $sqlHandle) {
		// $id < 0 tylko kasuje
		$name		= trim (str_replace ('&pipe', '|', $info [1]));		
		$query		= 'INSERT INTO `'.FARA_INTENTIONS_TYPES_TABLE.'` (`faraID`, `nazwa`) VALUES ('.$id.',"'.$name.'")';
		$sqlHhandle = @mysql_query ($query) or $this->sendErrorMessage ('Nie można wykonać: '.$query);		
	}
	$total++;
}	
return $total;
}

function loadSaints ($path) {
$query			= 'DELETE FROM `'.FARA_SAINTS_TABLE.'`';
$sqlHandle 		= @mysql_query ($query) or $this->sendErrorMessage ($query);
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  dzien, miesiac, nazwa, typ
	$day		= trim ($info [0]);
	if (strlen($day)==0) continue;
	$month		= $info [1];				
	$name		= trim (str_replace ('&pipe', '|', $info [2]));					
	$type		= trim (str_replace ('&pipe', '|', $info [3]));					
	$query		= 'INSERT INTO `'.FARA_SAINTS_TABLE.'` (`dzien`, `miesiac`, `nazwa`, `typ`) '.
				  'VALUES ('.$day.','.$month.',"'.$name.'","'.$type.'")';
	$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
	$total++;	
}
return $total;
}

function loadUserSaints ($path) {
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  id, dzien, miesiac, nazwa
	$id			= trim ($info [0]);	
	if (strlen($id)==0) continue;
	$query = 'DELETE FROM  `'.FARA_USER_SAINTS_TABLE.'` WHERE `faraID`='.abs($id);		
	$sqlHandle = @mysql_query ($query) or $this->sendErrorMessage ($query);
	if ($id>0 and $sqlHandle) {
		// $id < 0 tylko kasuje
		$day		= $info [1];
		$month		= $info [2];
		$name		= trim (str_replace ('&pipe', '|', $info [3]));			
		$query		= 'INSERT INTO `'.FARA_USER_SAINTS_TABLE.'` (`faraID`, `dzien`, `miesiac`, `nazwa`) '.
					  'VALUES ('.$id.','.$day.','.$month.',"'.$name.'")';
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;	
	}
}
return $total;
}

function loadMCelebrations ($path) {
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  id, data, nazwa, typ
	$id			= trim ($info [0]);
	if (strlen($id)==0) continue;	
	$date		= $info [1];	
	$query = 'DELETE FROM  `'.FARA_MCELEBRATIONS_TABLE.'` WHERE `faraID`='.abs($id);		
	$sqlHandle = @mysql_query ($query) or $this->sendErrorMessage ($query);
	if ($id>0 and $sqlHandle) {
		// $id < 0 tylko kasuje
		$name		= trim (str_replace ('&pipe', '|', $info [2]));					
		$type		= trim (str_replace ('&pipe', '|', $info [3]));					
		$query		= 'INSERT INTO `'.FARA_MCELEBRATIONS_TABLE.'` (`faraID`, `data`, `nazwa`, `typ`) '.
					   'VALUES ('.$id.','.$date.',"'.$name.'","'.$type.'")';
	$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
	$total++;	
	}
}
return $total;
}

function loadCCelebrations ($path) {
$contentArray 	= file ($path);
$total			= 0;
unlink ($path);
foreach ($contentArray as $line) {
	$info		= explode ('|', $line);			
	//  id, dzien, miesiac, nazwa
	$id			= trim ($info [0]);	
	if (strlen($id)==0) continue;
	$query = 'DELETE FROM  `'.FARA_CCELEBRATIONS_TABLE.'` WHERE `faraID`='.abs($id);		
	$sqlHandle = @mysql_query ($query) or $this->sendErrorMessage ($query);
	if ($id>0 and $sqlHandle) {
		// $id < 0 tylko kasuje
		$day		= $info [1];
		$month		= $info [2];
		$name		= trim (str_replace ('&pipe', '|', $info [3]));					
		$query		= 'INSERT INTO `'.FARA_CCELEBRATIONS_TABLE.'` (`faraID`, `dzien`, `miesiac`, `nazwa`) '.
					  'VALUES ('.$id.','.$day.','.$month.',"'.$name.'")';
		$sqlHandle 	= @mysql_query ($query) or $this->sendErrorMessage ($query);
		$total++;	
	}
}
return $total;
}
		
function faraPatroniDnia ($date) {
$month	= $this->getMonth ($date);
$day	= $this->getDayOfMonth ($date);
$query	= 'SELECT `nazwa`,`typ` FROM `'.FARA_SAINTS_TABLE.'` WHERE dzien='.$day.' and miesiac='.$month.' ORDER BY `typ` DESC, `nazwa`';
$handle = @mysql_query ($query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraPatroniDnia"'); 
	return '';
}
$rowsInResult = mysql_num_rows ($handle);
if ($rowsInResult == 0) return '';
$result = '';
for ($row=0; $row<$rowsInResult; $row++) {
	$record = @mysql_fetch_object ($handle);	
	if ($result) $result .= ', ';
	if ($record->typ) $result .= $record->typ.' ';
	$result .= $record->nazwa;
}
$query	= 'SELECT `nazwa` FROM `'.FARA_USER_SAINTS_TABLE.'` WHERE dzien='.$day.' and miesiac='.$month.' ORDER BY `nazwa`';
$handle = @mysql_query ($query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraPatroniDnia"'); 
	return $result;
}
$rowsInResult = mysql_num_rows ($handle);
if ($rowsInResult == 0) return $result;
for ($row=0; $row<$rowsInResult; $row++) {
	$record = @mysql_fetch_object ($handle);	
	if ($result) $result .= ', ';
	if ($record->typ) $result .= $record->typ.' ';
	$result .= $record->nazwa;
}
return $result;
}

function faraSwietoStale ($date) {
$month	= $this->getMonth ($date);
$day	= $this->getDayOfMonth ($date);
$query	= 'SELECT `nazwa` FROM `'.FARA_CCELEBRATIONS_TABLE.'` WHERE dzien='.$day.' and miesiac='.$month.' ORDER BY `nazwa`';
$handle = @mysql_query ($query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraSwietoStale"'); 
	return '';
}
$rowsInResult = mysql_num_rows ($handle);
if ($rowsInResult == 0) return '';
$result = '';
for ($row=0; $row<$rowsInResult; $row++) {
	$record = @mysql_fetch_object ($handle);	
	if ($result) $result .= ', ';
	$result .= $record->nazwa;
}
return $result;
}

function faraSwietoRuchome ($date) {
$query	= 'SELECT `nazwa`,`typ` FROM `'.FARA_MCELEBRATIONS_TABLE.'` WHERE `data`='.$date;
$handle = @mysql_query ($query);
if (!$handle) {
	$this->sendErrorMessage ('Zerwane połączenie z bazą danych w trakcie wykonywania funkcji "faraPatroniDnia"'); 
	return '';
}
$rowsInResult = mysql_num_rows ($handle);
if ($rowsInResult == 0) return '';
$result = '';
for ($row=0; $row<$rowsInResult; $row++) {
	$record = @mysql_fetch_object ($handle);	
	if ($result) $result .= ', ';
	if ($record->typ) $result .= $record->typ.' ';
	$result .= $record->nazwa;
}
return $result;
}

function getStartDate ($startDate) {
// Funkcja zwraca $startDate jeśli jest ona nie starsza niż dzisiaj, dzisiaj w przeciwnym przypadku
$date1 = $this->scriptDateFromString ($startDate);
return ($date1 >= $this->today()) ? $date1 : $this->today();
}

function getFirstDate () {
// Funkcja zwraca początkową datę z bazy danych
if ($this->history==FARA_INTENCJE_WSZYSTKO) return 0;	
if ($this->history==FARA_INTENCJE_OD_DZISIAJ) return $this->today();
if ($this->history==FARA_INTENCJE_OD_BIEZACEGO_TYGODNIA) return $this->thisWeekDate();
if ($this->history==FARA_INTENCJE_OD_BIEZACEGO_MIESIACA) return $this->thisMonthDate();
if ($this->history==FARA_INTENCJE_OD_POCZATKU_ROKU) return $this->thisYearDate();
return $this->today();
}

function fileNameExtension ($fileName) {
$elements = explode ('.', $fileName);
if (!$elements or count ($elements)==1) return '';
return strtolower ($elements[count($elements)-1]);
}

function getConfigFileName () {
$fileName = (func_num_args () > 0) ? func_get_arg (0) : '';
if (strlen ($fileName)==0) 		return FARA_DEFAULT_INI_STYLES_FILE;
if (!file_exists ($fileName)) 	return FARA_DEFAULT_INI_STYLES_FILE;
return $fileName;
}

function iniGetSection ($section, $configFile) {
$content = parse_ini_file ($configFile, TRUE);
return $content[$section];
}

function zapiszZgloszenie ($data, $godzina, $tresc, $zamawia, $uwagi, $typ, $kosciol, $telefon, $email) {
$ip			 = getenv ("REMOTE_ADDR");
$host		 = gethostbyaddr ($ip);
$currentTime = date ('d/m/Y H:i');
$content 	 = "<?xml version=\"1.0\" encoding=\"utf-8\"?>
<zgloszenie>
  <record>
   <ip>$ip</ip>
   <host>$host</host>
   <time>$currentTime</time>
   <data>$data</data>
   <godzina>$godzina</godzina>
   <tresc>$tresc</tresc>
   <zamawia>$zamawia</zamawia>
   <uwagi>$uwagi</uwagi>
   <typ>$typNazwa</typ>
   <kosciol>$kosciol</kosciol>
   <telefon>$telefon</telefon>
   <email>$email</email>  
  </record>
</zgloszenie>";
$this->saveContentToUniqueFile ($content, 'xml');
}

function saveContentToUniqueFile ($content, $extension) {
$fname = time().str_replace ('.', '', getenv ("REMOTE_ADDR"));
$fileName = $fname;
$i=0;
while (file_exists ($this->dbSourceFolder.'/'.FARA_ZGLOSZENIA_FOLDER.'/'.$fileName.'.'.$extension)) {
	$fileName = $fname.$i++;
}	
file_put_contents ($this->dbSourceFolder.'/'.FARA_ZGLOSZENIA_FOLDER.'/'.$fileName.'.'.$extension, $content);
}

} // END OF CLASS DEFINITION


?>